using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void RadGrid1_ItemCreated(object sender, Telerik.WebControls.GridItemEventArgs e)
    {
        if (e.Item is GridPagerItem)
        {
            GridPagerItem pagerItem = (GridPagerItem)e.Item;
            pagerItem.PagerContentCell.Controls.Clear();
            for (int i = 65; i <= 65 + 25; i++)
            {
                int recordcount = DataSourceHelperCS.GetLetterCount(((char)i).ToString());
                int pagecount = (int)(recordcount / RadGrid1.PageSize);

                for (int j = 0; j <= pagecount; j++)
                {
                    LinkButton linkButton1 = new LinkButton();
                    LiteralControl lc = new LiteralControl();

                    lc.Text = " ";
                    linkButton1.Text = "" + (char)(i) + j.ToString();

                    linkButton1.CommandName = "alpha";
                    linkButton1.CommandArgument = "" + (char)(i) + j.ToString();

                    pagerItem.PagerContentCell.Controls.Add(linkButton1);
                    pagerItem.PagerContentCell.Controls.Add(lc);
                }
            }
        }
    }

    protected void RadGrid1_ItemCommand(object source, Telerik.WebControls.GridCommandEventArgs e)
    {
        if (e.CommandName == "alpha")
        {
            string letterFilter = e.CommandArgument.ToString()[0].ToString();
            int pageNumber = int.Parse(e.CommandArgument.ToString()[1].ToString());
            int bot, top;

            bot = pageNumber * RadGrid1.PageSize;
            top = bot + RadGrid1.PageSize;

            DataTable table = DataSourceHelperCS.GetDataTable(string.Format("SELECT ContactName FROM (SELECT ROW_NUMBER() OVER (ORDER BY CustomerID ASC) AS Row, CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax FROM Customers WHERE ContactName LIKE \'{0}%\') AS CustomersWithNumbers WHERE Row >= {1} AND Row <= {2}", letterFilter, bot + 1, top));
            Session["GridSource"] = table;
            RadGrid1.MasterTableView.Rebind();
        }
        if (e.CommandName == "ShowAll")
        {
            DataTable table = DataSourceHelperCS.GetDataTable("SELECT ContactName FROM Customers");
            Session["GridSource"] = table;

            RadGrid1.MasterTableView.Rebind();
        }
    }
    protected void RadGrid1_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
    {
        if (Session["GridSource"] == null)
        {
            RadGrid1.DataSource = DataSourceHelperCS.GetDataTable("SELECT ContactName FROM Customers");
            Session["GridSource"] = RadGrid1.DataSource;
        }
        else
        {
            RadGrid1.DataSource = Session["GridSource"] as DataTable;
        }
    }

    public class DataSourceHelperCS
    {
        public static DataTable GetDataTable(string selectstr)
        {
            SqlConnection conn = new SqlConnection("Data Source=MILEV;Initial Catalog=Northwind;Integrated Security=True");

            try
            {
                conn.Open();
                SqlCommand cmd = new SqlCommand(selectstr);
                cmd.Connection = conn;
                SqlDataAdapter adapt = new SqlDataAdapter(cmd);
                DataTable table = new DataTable();
                adapt.Fill(table);
                return table;
            }
            catch (Exception ex)
            {
                HttpContext.Current.Response.Write(ex.Message);
                return null;
            }
            finally
            {
                conn.Close();
            }
        }

        public static int GetLetterCount(string selectchar)
        {
            string selectstr = "SELECT COUNT(ContactName) FROM Customers WHERE ContactName LIKE \'" + selectchar + "%\'";
            SqlConnection conn = new SqlConnection("Data Source=MILEV;Initial Catalog=Northwind;Integrated Security=True");

            try
            {
                conn.Open();
                SqlCommand cmd = new SqlCommand(selectstr);
                cmd.Connection = conn;
                SqlDataAdapter adapt = new SqlDataAdapter(cmd);
                int rows = int.Parse(cmd.ExecuteScalar().ToString());
                return rows;
            }
            catch (Exception ex)
            {
                HttpContext.Current.Response.Write(ex.Message);
                return 0;
            }
            finally
            {
                conn.Close();
            }
        }
    }

}
